
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


static unsigned int get_word(unsigned char *p){
	return (p[0] | (p[1] << 8));
}



static int expand(unsigned char *dest, int dest_size, unsigned char *src, int src_size){
	int src_ofs;
	int dest_ofs;
	int flag;
	int k;

	src_ofs = 0;
	dest_ofs = 0;

	k = 0;
	while(src_size > src_ofs){
		int c;

		if(dest_size <= dest_ofs){
			break;
		}

		if(0 >= k){
			flag = get_word(src + src_ofs);
//printf("f: %04x (%x\n", flag, (src_ofs + 2));
			src_ofs += 2;
			k = 16;
		}

		c = (flag & 0x8000);
		flag <<= 1;
		k -= 1;
		if(0 >= k){
			flag = get_word(src + src_ofs);
//printf("f: %04x (%x\n", flag, (src_ofs + 2));
			src_ofs += 2;
			k = 16;
		}

		if(0 == c){
			int t_len;
			t_len = src[src_ofs];
			src_ofs += 1;

//printf("n: %x (%x\n", t_len, (src_ofs + 1));

			if(0 != (t_len & 1)){
				t_len >>= 1;
				memset((dest + dest_ofs), src[src_ofs], t_len);
				dest_ofs += t_len;
				src_ofs += 1;
			}
			else{
				t_len >>= 1;
				memcpy((dest + dest_ofs), (src + src_ofs), t_len);
				dest_ofs += t_len;
				src_ofs += t_len;
			}
		}
		else{
			int t_len, t_ofs;

			t_ofs = get_word(src + src_ofs);
			src_ofs += 2;

//printf("c: %04x (%x\n", t_ofs, src_ofs);

			t_len = (((t_ofs >> 12) & 0x0f) + 3);
			t_ofs = (dest_ofs - (t_ofs & 0xfff));

			memcpy((dest + dest_ofs), (dest + t_ofs), t_len);
			dest_ofs += t_len;
		}

	}

	return dest_ofs;
}




int main(int argc, char *argv[]){
	unsigned char *src, *dest;
	int size, dest_size;

	if(argc < 2){
		exit(0);
	}


	{
		FILE *fp;
		fp = fopen(argv[1], "rb");
		if(NULL == fp){
			exit(1);
		}
		fseek(fp, 0, SEEK_END);
		size = ftell(fp);
		src = malloc(size);
		if(NULL == src){
			fclose(fp);
			exit(1);
		}
		fseek(fp, 0, SEEK_SET);
		fread(src, 1, size, fp);
		fclose(fp);
	}

	dest_size = get_word(src);

	dest = malloc(dest_size);
	if(NULL == dest){
		free(src);
		exit(1);
	}

	dest_size = expand(dest, dest_size, (src + 2), (size - 2));

	if(0 < dest_size){
		FILE *fp;
		char *p;
		p = argv[1];
		if(3 <= argc){
			p = argv[2];
		}
		fp = fopen(p, "wb");
		fwrite(dest, 1, dest_size, fp);
		fclose(fp);
	}

	free(dest);
	free(src);

	exit(0);
}
